// 

#include <esplib.h>
#define FILE "lenti_test.png"

double pitch;
int px,py;
int aaflg;
int pic_num,view_num;
int gap,po;



void SubPixel_pset(int x, int y, int col)
{
    int gpos_x,gpos_y;
    int r,g,b;
    int p,p1,p2,p3;

    gpos_x  = x/3;
    gpos_y = y*3;

	r = col & 0xff0000;
	g = col & 0x00ff00;
	b = col & 0x0000ff;

    switch(x % 3)
    {
    case 0:
//        ESP_Select(0);
        p1 = ESP_Point(gpos_x, gpos_y);
        p2 = ESP_Point(gpos_x, gpos_y+1);
        p3 = ESP_Point(gpos_x, gpos_y+2);
//        ESP_Select(1);
        ESP_Pset(gpos_x, gpos_y,    (p1 & 0x00ffff) | r);
        ESP_Pset(gpos_x, gpos_y+1, (p2 & 0xff00ff) | g);
        ESP_Pset(gpos_x, gpos_y+2, (p3 & 0xffff00) | b);
        break;
    case 2:
//        ESP_Select(0);
        p1 = ESP_Point(gpos_x, gpos_y);
        p2 = ESP_Point(gpos_x, gpos_y+1);
        p3 = ESP_Point(gpos_x+1, gpos_y+2);
//        ESP_Select(1);
        ESP_Pset(gpos_x, gpos_y,    (p1 & 0xff00ff) | g);
        ESP_Pset(gpos_x, gpos_y+1, (p2 & 0xffff00) | b);
        ESP_Pset(gpos_x+1, gpos_y+2, (p3 & 0x00ffff) | r);
        break;
    case 1:
//        ESP_Select(0);
        p1 = ESP_Point(gpos_x, gpos_y);
        p2 = ESP_Point(gpos_x+1, gpos_y+1);
        p3 = ESP_Point(gpos_x+1, gpos_y+2);
//        ESP_Select(1);
        ESP_Pset(gpos_x, gpos_y,    (p1 & 0xffff00) | b);
        ESP_Pset(gpos_x+1, gpos_y+1, (p2 & 0x00fffff) | r);
        ESP_Pset(gpos_x+1, gpos_y+2, (p3 & 0xff00ff) | g);
        break;
    }
}

void SubPixel_Vline(int sx, int sy, int count, int col)
{

	for (int i=0;i<count;i++)
	{
		SubPixel_pset(sx, sy,col);
		sx += 3;
		sy++;
	}
}


void ESP_Ready(void)
{
//	pitch=7.3;
//	pitch=5.498;
//	pitch=7.291;
//	pitch=7.294;
	pitch=23.006;

	pic_num = 2; view_num = 2;

	ESP_OpenTextWindow(0,0,0,198,198);

	ESP_OpenButtonBox(200,0,2,10);

	ESP_SetButtonBoxTitle(0,"pitch-");
	ESP_SetButtonBoxTitle(1,"pitch+");
	ESP_SetButtonBoxTitle(2,"pitch-0.01");
	ESP_SetButtonBoxTitle(3,"pitch+0.01");
	ESP_SetButtonBoxTitle(4,"pitch-0.001");
	ESP_SetButtonBoxTitle(5,"pitch+0.001");
	ESP_SetButtonBoxTitle(6,"break");
	ESP_SetButtonBoxTitle(7,"cap");
	ESP_SetButtonBoxTitle(8,"pic-");
	ESP_SetButtonBoxTitle(9,"pic+");
	ESP_SetButtonBoxTitle(10,"view-");
	ESP_SetButtonBoxTitle(11,"view+");
	ESP_SetButtonBoxTitle(12,"AA on");
	ESP_SetButtonBoxTitle(13,"AA off");	
	ESP_SetButtonBoxTitle(14,"gap-");
	ESP_SetButtonBoxTitle(15,"gap+");
	ESP_SetButtonBoxTitle(16,"pos-");
	ESP_SetButtonBoxTitle(17,"pos+");
}

//#define heikin(c0,c1) RGB2C((C2R(c0)+C2R(c1))/2, (C2G(c0)+C2G(c1))/2, (C2B(c0)+C2B(c1))/2)








int aa(int c0,int c1,double dt)
{
double r,g,b;
r = (double(C2R(c0))*dt+double(C2R(c1))*(1.0-dt));
g = (double(C2G(c0))*dt+double(C2G(c1))*(1.0-dt));
b = (double(C2B(c0))*dt+double(C2B(c1))*(1.0-dt));

return(RGB2C(int(r),int(g),int(b)));
}


void draw()
{
double p,p0;
int col;
//int dt;
int lcount;
int col0;
int pp;

lcount=0;
p0=0.0;
p=pitch;

double dt;
dt = pitch/view_num;
double px_th;
px_th=dt;
px = 0;
int pic_pos;
int pic_w;
pic_w = esp_iw[1].wx/pic_num;

int last_col[480];
int firstpx=0;
double last_dt;

int ct[10];
int ct_dt[10];
int pic_pos0,px0;
double px_th0;
int pct;

double cdt;
double pitch_th;
pitch_th = pitch;

//while(px<800){
while(px<2400){

	px0 = px;
	px_th0 = px_th;

	pct=0;pic_pos = 0;
	while(pic_pos<view_num){

		px0++;
		if (px0>=(int(px_th0))) {
			ct[pic_pos] = px+pct;
			ct_dt[pic_pos] = pct;
			pct = 0;
			px_th0 += dt;
			pic_pos++;
		} else pct++;

	}


	pct =0;pic_pos = 0;
	while(pic_pos<view_num){
		cdt = pitch/(ct_dt[pic_pos]);

		int tx;
		int tt=0;
		tx = px;
		for (int j=0; j<160; j++){
			ESP_Select(1);
			col0=ESP_Point( pic_w*pic_pos + int(pitch_th) - int(pct*cdt)+tt, j*3 );
//			col0=ESP_Point( pic_w*pic_pos + int(pitch_th) - int(pct*cdt), j*3 );
			if ((firstpx)&&(aaflg)) 
				col = aa(last_col[j], col0, last_dt);
			else
				col = col0;
			last_col[j] = col0;

			if (pct<gap) col = 0x000000;

			ESP_Select(2);
//			ESP_Pset(px,j,col);
/*
//܂D܂Ȃ
			SubPixel_pset(tx*3, j,col);
			SubPixel_pset(tx*3+1, j,col);
			SubPixel_pset(tx*3+2, j,col);
			tx ++;
			*/
			if (pic_pos)
				SubPixel_pset(tx+po, j,col);
			else
				SubPixel_pset(tx, j,col);
			tx += 3;

			tt+=3;

		}
		firstpx=0;

		px++;
		if (px>=(int(px_th))) {
			last_dt= px_th-(int(px_th));
			pct = 0;
			px_th += dt;
			pic_pos++;
			firstpx = 1;
		} else pct++;

	}
	pitch_th = px_th;
}


ESP_Update();
	ESP_ClearTextWindow();
	ESP_Printf("pitch: %f\n",pitch);
	ESP_Printf("dt: %f\n",dt);
	ESP_Printf("pic_num: %d\n",pic_num);
	ESP_Printf("view_num: %d\n",view_num);
	ESP_Printf("gap: %d\n",gap);
	ESP_Printf("pos: %d\n",po	);
	if (aaflg)
		ESP_Printf("AA: on");
	else
		ESP_Printf("AA: off");

}


void ESP_Main(void)

{
	if (ESP_GetDisplayMode(0)) {

//		ESP_CreateImage( 1,  "Hello,there!", 0,0,800,400,100);
		ESP_CreateImage( 1,  "work", 0,300,esp_iw[0].wx*3,esp_iw[0].wy,10);

		for (int j=0;j<esp_iw[0].wy;j++){
		for (int i=0;i<esp_iw[0].wx;i++){
			ESP_Select(0);
			int c=ESP_Point(i, j);

			ESP_Select(1);
			ESP_Pset(i*3, j, c);
			ESP_Pset(i*3+1, j, c);
			ESP_Pset(i*3+2, j, c);
		}
		}

		ESP_CreateImage( 2,  "Hello,there!", px,py,800,480,100);

		draw();


	while(1){
			for (int b=0; b<22; b++){
					ESP_Printf("");//ȂƑs\BȂŁH

				if(ESP_GetButtonBox(b)){
				switch(b){
					case 0:
//						pitch -= 0.5;
						pitch -= 0.1;
//						pitch -= 0.05;
						if (pitch<1) pitch=1;
						break;
					case 1:
//						pitch += 0.5;
						pitch += 0.1;
//						pitch += 0.05;
						if (pitch>50) pitch=50;
						break;

					case 2:
						pitch -= 0.01;
						if (pitch<1) pitch=1;
						break;
					case 3:
						pitch += 0.01;
						if (pitch>50) pitch=50;
						break;
					case 4:
						pitch -= 0.001;
						if (pitch<1) pitch=1;
						break;
					case 5:
						pitch += 0.001;
						if (pitch>50) pitch=50;
						break;
					case 6:
						LPRECT pos;
						GetWindowRect(esp_iw[2].hwnd, pos);
						px = pos->left;
						py = pos->top;
//ESP_Printf("count: %d\n",pos->left);
//ESP_Printf("count: %d\n",pos->top);
						goto end;
						break;
					case 7:
						ESP_ImageSave(ESP_PNG, FILE, 0, 0, esp_iw[2].wx, esp_iw[2].wy);
						break;
					case 8:
						pic_num -= 1;
						if (pic_num<2) pic_num=2;
						break;
					case 9:
						pic_num += 1;
						break;
					case 10:
						view_num -= 1;
						if (view_num<2) view_num=2;
						break;
					case 11:
						view_num += 1;
						break;
					case 12:
						if (aaflg==0) aaflg =1;
						break;
					case 13:
						if (aaflg==1) aaflg =0;
						break;
					case 14:
						gap -= 1;
						if (gap<0) gap =0;
						break;
					case 15:
						gap += 1;
						break;
					case 16:
						po -= 1;
						break;
					case 17:
						po += 1;
						break;

				}
				draw();
				}
			}
	}//while
end:	



//		ESP_Pause("ϊI");
	
		ESP_DestroyImage(0);
		ESP_DestroyImage(1);
		ESP_DestroyImage(2);
		
		} else {
		ESP_Pause("XeIyA摜hbOĉ");
	}
}
void ESP_Finish(void)
{
}

